(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var SandstormDb = Package['sandstorm-db'].SandstormDb;

(function(){

////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                            //
// packages/sandstorm-ui-autocomplete-input/autocomplete-server.js                            //
//                                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                              //
Meteor.publish("userContacts", function () {                                                  // 1
  var db = this.connection.sandstormDb;                                                       // 2
  var self = this;                                                                            // 3
                                                                                              // 4
  // We maintain a map from identity IDs to live query handles that track profile changes.    // 5
  var contactIdentities = {};                                                                 // 6
                                                                                              // 7
  var self = this;                                                                            // 8
  function addIdentityOfContact(contact) {                                                    // 9
    if (!(contact.identityId in contactIdentities)) {                                         // 10
      var user = Meteor.users.findOne({_id: contact.identityId});                             // 11
      if (user) {                                                                             // 12
        SandstormDb.fillInProfileDefaults(user);                                              // 13
        SandstormDb.fillInIntrinsicName(user);                                                // 14
        var filteredUser = _.pick(user, "_id", "profile");                                    // 15
        self.added("userContacts", user._id, filteredUser);                                   // 16
      }                                                                                       // 17
      contactIdentities[contact.identityId] =                                                 // 18
        Meteor.users.find({_id: contact.identityId}, {fields: {profile: 1}}).observeChanges({
          changed: function (id, fields) {                                                    // 20
            self.changed("userContacts", id, fields);                                         // 21
          }                                                                                   // 22
        });                                                                                   // 23
    }                                                                                         // 24
  }                                                                                           // 25
  var cursor = db.collections.contacts.find({ownerId: this.userId});                          // 26
                                                                                              // 27
  var handle = cursor.observe({                                                               // 28
    added: function (contact) {                                                               // 29
      addIdentityOfContact(contact);                                                          // 30
    },                                                                                        // 31
    changed: function (contact) {                                                             // 32
      addIdentityOfContact(contact);                                                          // 33
    },                                                                                        // 34
    removed: function (contact) {                                                             // 35
      self.removed("userContacts", contact.identityId);                                       // 36
      contactIdentities[contact.identityId].stop();                                           // 37
      delete contactIdentities[contact.identityId];                                           // 38
    },                                                                                        // 39
  });                                                                                         // 40
  this.ready();                                                                               // 41
                                                                                              // 42
  this.onStop(function() {                                                                    // 43
    handle.stop();                                                                            // 44
    Object.keys(contactIdentities).forEach(function(identityId) {                             // 45
      contactIdentities[identityId].stop();                                                   // 46
      delete contactIdentities[identityId];                                                   // 47
    });                                                                                       // 48
  });                                                                                         // 49
});                                                                                           // 50
                                                                                              // 51
////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-ui-autocomplete-input'] = {};

})();

//# sourceMappingURL=sandstorm-ui-autocomplete-input.js.map
